F - Prime Path  POJ - 3126 (宽搜BFS)

F - Prime Path

 POJ - 3126 

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033 
1733 
3733 
3739 
3779 
8779 
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:给你两个四位素数,每次变换第一个数的一位,变化后得到的数也必须是素数,求最少变换几次可以由第一个数得到第二个数。或者不存在

 

#include <iostream>
#include <cstring>
#include <cstdio>
#include <queue>
#include <algorithm>
#include <cmath>
using namespace std;
#define mem(f, x) memset(f,x,sizeof(f))
#define sca(x) scanf("%d", &x)
#define sca2(x,y) scanf("%d%d",&x,&y)
#define sca3(x,y,z) scanf("%d%d%d",&x,&y,&z)
#define scl(x) scanf("%lld",&x);
#define pri(x) printf("%d\n", x)
#define prl(x) printf("%lld\n",x);
#define ll long long
const int inf=1e9+7;
const int maxn=2e6+5;
int  n,m,k,flag,f,s,e;
#define mod (ll)(1e9+7)
#define pi 3.1415926

int vis[11111],book[11111];

struct node{
   int x,step;
};

void init()
{
    vis[1]=1;
    for(int i=2;i<11111;i++)
    {
        if(!vis[i])
        {
            for(int j=i*2;j<11111;j+=i)
            {
                vis[j]=1;
            }
        }
    }
}


void bfs()
{
    queue<node> q;
    node a;
    a.step=0;
    a.x=s;
    book[s]=1;
    q.push(a);
    while(q.size()){
        node b;
        b=q.front();
        q.pop();
        if(b.x==e){
            cout<<b.step<<endl;
            return;
        }
      //  cout<<b.x<<endl;
        for(int i=1;i<=4;i++)
        {

            for(int j=0;j<=9;j++)
            {
                int t=b.x;
                 int d[6];
                int cnt=1;
                while(t)
                {
                    d[cnt++]=(t%10);
                    t/=10;
                }
               if(d[i]!=j){
                d[i]=j;
                int temp=0;
                for(int k=4;k>=1;k--){
                    temp=temp*10+d[k];
                }
                if(temp>1000&&temp<9999&&vis[temp]==0&&book[temp]==0)
                {
                    node c;
                    c.step=b.step+1;
                    c.x=temp;
                    book[temp]=1;
                    q.push(c);
                }
                }
            }
        }
    }
    cout<<"Impossible"<<endl;
    return ;
}


int main()
{
    int T;
    cin>>T;
    mem(vis,0);
    init();
    while(T--){
            mem(book,0);
         cin>>s>>e;
         bfs();
    }
    return 0;
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值